"use strict";
/**
 * Base communication layer for the SharePoint Framework
 *
 * @remarks
 * This package defines the base communication layer for
 * the SharePoint Framework.  For REST calls, it handles authentication,
 * logging, diagnostics, and batching.  It also simplifies requests by
 * adding default headers that follow the recommended best practices.
 *
 * @packagedocumentation
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MSGraphClientFactory = exports.MSGraphClient = exports._DEPRECATED_DO_NOT_USE_GraphHttpClientResponse = exports._DEPRECATED_DO_NOT_USE_GraphHttpClientConfiguration = exports._DEPRECATED_DO_NOT_USE_GraphHttpClient = exports.SPHttpHeader = exports.SPHttpClientResponse = exports.SPHttpClientConfiguration = exports.SPHttpClientCommonConfiguration = exports.SPHttpClientBatchConfiguration = exports.SPHttpClientBatch = exports.SPHttpClient = exports.ODataVersion = exports.DigestCache = exports.DEPRECATED_DO_NOT_USE_OAuthTokenProvider = exports.AadTokenProviderFactory = exports.TokenAcquisitionEventArgs = exports.AadTokenProvider = exports.BeforeRedirectEventArgs = exports.PopupEventArgs = exports.HttpClientResponse = exports.HttpClientConfiguration = exports.HttpClient = exports.AadHttpClientResponse = exports.AadHttpClientFactory = exports.AadHttpClientConfiguration = exports.AadHttpClient = void 0;
var sp_http_base_1 = require("@microsoft/sp-http-base");
Object.defineProperty(exports, "AadHttpClient", { enumerable: true, get: function () { return sp_http_base_1.AadHttpClient; } });
Object.defineProperty(exports, "AadHttpClientConfiguration", { enumerable: true, get: function () { return sp_http_base_1.AadHttpClientConfiguration; } });
Object.defineProperty(exports, "AadHttpClientFactory", { enumerable: true, get: function () { return sp_http_base_1.AadHttpClientFactory; } });
Object.defineProperty(exports, "AadHttpClientResponse", { enumerable: true, get: function () { return sp_http_base_1.AadHttpClientResponse; } });
Object.defineProperty(exports, "HttpClient", { enumerable: true, get: function () { return sp_http_base_1.HttpClient; } });
Object.defineProperty(exports, "HttpClientConfiguration", { enumerable: true, get: function () { return sp_http_base_1.HttpClientConfiguration; } });
Object.defineProperty(exports, "HttpClientResponse", { enumerable: true, get: function () { return sp_http_base_1.HttpClientResponse; } });
Object.defineProperty(exports, "PopupEventArgs", { enumerable: true, get: function () { return sp_http_base_1.PopupEventArgs; } });
Object.defineProperty(exports, "BeforeRedirectEventArgs", { enumerable: true, get: function () { return sp_http_base_1.BeforeRedirectEventArgs; } });
Object.defineProperty(exports, "AadTokenProvider", { enumerable: true, get: function () { return sp_http_base_1.AadTokenProvider; } });
Object.defineProperty(exports, "TokenAcquisitionEventArgs", { enumerable: true, get: function () { return sp_http_base_1.TokenAcquisitionEventArgs; } });
Object.defineProperty(exports, "AadTokenProviderFactory", { enumerable: true, get: function () { return sp_http_base_1.AadTokenProviderFactory; } });
Object.defineProperty(exports, "DEPRECATED_DO_NOT_USE_OAuthTokenProvider", { enumerable: true, get: function () { return sp_http_base_1.DEPRECATED_DO_NOT_USE_OAuthTokenProvider; } });
Object.defineProperty(exports, "DigestCache", { enumerable: true, get: function () { return sp_http_base_1.DigestCache; } });
Object.defineProperty(exports, "ODataVersion", { enumerable: true, get: function () { return sp_http_base_1.ODataVersion; } });
Object.defineProperty(exports, "SPHttpClient", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClient; } });
Object.defineProperty(exports, "SPHttpClientBatch", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClientBatch; } });
Object.defineProperty(exports, "SPHttpClientBatchConfiguration", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClientBatchConfiguration; } });
Object.defineProperty(exports, "SPHttpClientCommonConfiguration", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClientCommonConfiguration; } });
Object.defineProperty(exports, "SPHttpClientConfiguration", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClientConfiguration; } });
Object.defineProperty(exports, "SPHttpClientResponse", { enumerable: true, get: function () { return sp_http_base_1.SPHttpClientResponse; } });
Object.defineProperty(exports, "SPHttpHeader", { enumerable: true, get: function () { return sp_http_base_1.SPHttpHeader; } });
var DEPRECATED_DO_NOT_USE_GraphHttpClient_1 = require("./graphHttpClient/DEPRECATED_DO_NOT_USE_GraphHttpClient");
Object.defineProperty(exports, "_DEPRECATED_DO_NOT_USE_GraphHttpClient", { enumerable: true, get: function () { return __importDefault(DEPRECATED_DO_NOT_USE_GraphHttpClient_1).default; } });
var DEPRECATED_DO_NOT_USE_GraphHttpClientConfiguration_1 = require("./graphHttpClient/DEPRECATED_DO_NOT_USE_GraphHttpClientConfiguration");
Object.defineProperty(exports, "_DEPRECATED_DO_NOT_USE_GraphHttpClientConfiguration", { enumerable: true, get: function () { return __importDefault(DEPRECATED_DO_NOT_USE_GraphHttpClientConfiguration_1).default; } });
var DEPRECATED_DO_NOT_USE_GraphHttpClientResponse_1 = require("./graphHttpClient/DEPRECATED_DO_NOT_USE_GraphHttpClientResponse");
Object.defineProperty(exports, "_DEPRECATED_DO_NOT_USE_GraphHttpClientResponse", { enumerable: true, get: function () { return __importDefault(DEPRECATED_DO_NOT_USE_GraphHttpClientResponse_1).default; } });
var sp_http_msgraph_1 = require("@microsoft/sp-http-msgraph");
Object.defineProperty(exports, "MSGraphClient", { enumerable: true, get: function () { return sp_http_msgraph_1.MSGraphClient; } });
Object.defineProperty(exports, "MSGraphClientFactory", { enumerable: true, get: function () { return sp_http_msgraph_1.MSGraphClientFactory; } });
//# sourceMappingURL=index.js.map